(**    The ocamlduce definition of the XML/AADL format.
 
  Time-stamp: <modified the 31/08/2007 (at 14:02) by Erwan Jahier>  

 
  This file was obtained by:
       - DTDGenerator (http://www.xml.com/pub/a/2002/08/28/validation.html), 
       - dtd2types (http://yquem.inria.fr/~frisch/ocamlcduce/samples/dtd2types/)
 
  and then made more precise by hand, as suggested in
  http://yquem.inria.fr/~frisch/ocamlcduce/samples/schema/schema_dtd.ml
     
  Note that this has not been tested intensively. Note also that the aaxl format 
  is defined nowhere... I can only guess looking at what the eclipse plugin 
  of OSATE outputs.

       @see
       <http://www-verimag.imag.fr/~synchron/aadl4ocaml/doc/code_Aadl_dtd.html>
       ocamlducedoc fails to generate doc for this file, sorry.  You'd
       better look in the source code  directly
       
       @author Erwan Jahier  

*)

{{ namespace xmlns="http://www.w3.org/2001/XMLSchema" }}
{{ namespace xsi="http://www.w3.org/2001/XMLSchema-instance"  }}
{{ namespace xmi="http://www.omg.org/XMI" }}

(* XXX where to put those files so that they are always easily available? 
   (in particular when there is no network)
*)
{{ namespace core="file:///tmp/aadl-schema/core" }}
(* {{ namespace core="http:///www-verimag.imag.fr/~jahier/xsd/AADLXMI/core" }} *)

(**/**)

type aadlSpec =
    {{<core:AadlSpec 
	 xmlns:xsi=?String 
	 xmlns:xmi=?String 
	 xmlns:property=?String 
	 xmlns:core=?String 
	 xmi:version=String 
	 name=String>
	 [ aadlDeclaration *]
     }}

 and aadlDeclaration =
    {{ 
       aadlPackage_declaration (** Components can be declared inside a package *)
     | component_declaration   (** or not *)
     }}


 and aadlPackage_declaration = 
    {{<aadlPackage name=String> [ aadlPackage ]}}
(*      | property_set *)

 and aadlPackage = {{ aadlPublic | aadlPrivate | [aadlPublic aadlPrivate] }}

 and aadlPublic  = {{<aadlPublic> [ component_declaration* ]}}
 and aadlPrivate = {{<aadlPrivate>[ component_declaration* ]}}

 and component_declaration =
    {{
         busImpl 
       | busType 
       | deviceType 
       | deviceImpl 
       | memoryImpl 
       | memoryType 
       | processImpl 
       | processType 
       | processorImpl 
       | processorType 
       | subprogramType 
       | subprogramImpl 
       | threadImpl 
       | threadType
       | dataType
       | dataImpl
       | systemType 
       | systemImpl
       | portGroupType       
     }}
      
(** {3 Ports} *)
 and portGroupType = 
    {{<portGroupType name=String inverseOf=?String>[ features? ]}}

(** {3 Components} *)

 and component_body_impl = 
    {{ subcomponents | callSequences | connections | flows | properties  }}
 and component_body_type = 
    {{ features | flowSpecs | properties }} 


(** {3 Data} *)
 and dataType = {{<dataType name=String> [component_body_type*] }}
 and dataImpl = {{<dataImpl name=String compType=String> [component_body_impl*] }}


(** {3 Subprograms} *)
 and subprogramType = {{<subprogramType name=String>[ component_body_type* ]}}
 and subprogramImpl = {{<subprogramImpl name=String compType=String>
			   [ component_body_impl* ]}}

(** {3 Systems} *)
 and systemType = {{<systemType name=String>[  component_body_type* ]}}
 and systemImpl = {{<systemImpl name=String compType=String>
		       [ component_body_impl* ]}}


(** {3 Process}  *)
 and processType = 
    {{<processType name=String>[ component_body_type* ]}}
    
 and processImpl = 
    {{<processImpl name=String compType=String> [component_body_impl* ]}}


(** {3 Processors} *)
 and processorType = 
    {{<processorType name=String>[ component_body_type*  ]}}
 and processorImpl = 
    {{<processorImpl name=String compType=String>[ component_body_impl* ]}}


(** {3 Bus} *)
 and busType = {{<busType name=String>[ component_body_type* ]}}
 and busImpl = {{<busImpl name=String compType=String>[ component_body_impl* ]}}


(** {3 Memory} *)
 and memoryType = {{<memoryType name=String>[ component_body_type* ]}}
 and memoryImpl = {{<memoryImpl name=String compType=String>[ component_body_impl* ]}}


(** {3 Devices} *)
 and deviceType = {{<deviceType name=String>[ component_body_type* ]}}
 and deviceImpl = {{<deviceImpl name=String compType=String>
		       [ component_body_impl* ]}}
 

(** {3 Threads} *)
 and threadType = {{<threadType name=String>[ component_body_type*  ]}}
 and threadImpl = 
    {{<threadImpl name=String compType=String>[ component_body_impl* ]}}


(***{3 *******************************************************************************)

(** {3 Features} *)
 and features = 
    {{<features>[ feature_body* ]}}

 and feature_body =
   {{
      busAccess 
    | dataAccess
    | dataPort 
    | eventDataPort 
    | eventPort 
    | portGroup
    | parameter
    }}
      (** XXX missing features :
	 | serverSubprogramSpec
	 | dataSubprogramSpec
	 | subcomponentAccess
      *)

 and busAccess = 
    {{<busAccess direction=?String name=String busClassifier=?String>[properties*]}}

 and dataAccess = 
    {{<dataAccess direction=?String name=String dataClassifier=?String>[properties*]}}

 and dataPort = 
    {{<dataPort name=String direction=?String  dataClassifier=?String>[properties*]}}

 and eventDataPort = 
    {{<eventDataPort name=String direction=?String  dataClassifier=?String>[properties*]}}

 and eventPort = 
    {{<eventPort name=String direction=?String>[properties*]}}

 and portGroup = 
    {{<portGroup portGroupType=String name=String>[properties*]}}

 and parameter = 
    {{<parameter name=String direction=?String dataClassifier=?String>[properties*]}} 


(**********************************************************************************)
(** {3 Subcomponents} *)
 and subcomponents = {{<subcomponents>[subcomponents_body*]}}

 and subcomponents_body =
    {{
       processSubcomponent
     | processorSubcomponent
     | deviceSubcomponent
     | busSubcomponent
     | threadSubcomponent
     | memorySubcomponent 
     | dataSubcomponent 
     }}

 and processSubcomponent = 
    {{<processSubcomponent name=String classifier=?String>[properties*]}}
 
 and processorSubcomponent = 
    {{<processorSubcomponent name=String classifier=?String>[properties*]}}

 and busSubcomponent = 
    {{<busSubcomponent name=String classifier=?String>[properties*]}}

 and memorySubcomponent = 
    {{<memorySubcomponent name=String classifier=?String>[properties*]}}

 and dataSubcomponent = 
    {{<dataSubcomponent name=String classifier=?String>[properties*]}}

 and deviceSubcomponent = 
    {{<deviceSubcomponent name=String classifier=?String>[properties*]}}

 and threadSubcomponent = 
    {{<threadSubcomponent name=String classifier=?String>[properties*]}}


(** {3 Call} *)
 and call = {{<call name=String classifier=String>[properties*]}}
 and callSequences = {{<callSequences>[ callSequence* ]}}
 and callSequence = {{<callSequence>[ call* ]}}


(** {3 Connection} *)
 and connections = {{<connections>[connections_body*]}}

 and connections_body =
   {{
      dataConnection 
    | eventConnection 
    | eventDataConnection 
    | parameterConnection 
    | portGroupConnection 
    | busAccessConnection 
    | dataAccessConnection 
    }}
    
 and dataConnection = 
    {{<dataConnection 
	 timing=?String
	 srcContext=?String src=String name=?String dstContext=?String dst=String>
	 [ properties* ]}}

 and eventConnection = 
    {{<eventConnection 
	 timing=?String srcContext=?String src=String dstContext=?String dst=String>
	 [ properties* ]}}

 and eventDataConnection = 
    {{<eventDataConnection 
	 timing=?String 
	 name=?String srcContext=?String src=String dstContext=?String dst=String>
	 [ properties* ]}}

 and parameterConnection = 
    {{<parameterConnection 
	 srcContext=?String src=String name=?String dstContext=?String dst=String>
	 [ properties* ]}}

 and portGroupConnection = 
    {{<portGroupConnection 
	 srcContext=?String src=String dstContext=?String dst=String>
	 [ properties* ]}}
      
 and busAccessConnection = 
    {{<busAccessConnection 
	 srcContext=?String src=String dstContext=?String dst=String>
	 [ properties* ]}}

 and dataAccessConnection = 
    {{<dataAccessConnection 
	 srcContext=?String src=String dstContext=?String dst=String>
	 [ properties* ]}}


(** {3 Flows} *)
 and flows = {{<flows>[ flowPathImpl+ | endToEndFlow+ ]}}

 and flowSpecs = 
    {{<flowSpecs>[ ( flowSinkSpec | flowSourceSpec | flowPathSpec )* ]}}

 and flowPathSpec = 
    {{<flowPathSpec src=String name=String dst=String>[ properties? ]}}

 and flowPathImpl = 
    {{<flowPathImpl name=String implement=String>[ flowElement+ ]}}

 and flowElement = 
    {{<flowElement flowSpec=?String flowContext=?String connection=?String>[]}}

 and flowSourceSpec = {{<flowSourceSpec name=String dst=String>[  ]}}

 and flowSinkSpec = {{<flowSinkSpec src=String name=String>[  ]}}

 and endToEndFlow = {{<endToEndFlow name=String>[ ( properties flowElement+ )]}}


(** {3 Properties} *)

 and properties = {{<properties>[ propertyAssociation+ ]}}

 and propertyAssociation = 
    {{<propertyAssociation propertyDefinition=String appliesTo=?String access=?String>
	 [propertyExpression*]}}
      

 and propertyChoice = 
    {{
       "property:ReferenceValue"
     | "property:EnumValue" 
     | "property:StringValue" 
     | "property:IntegerRangeValue" 
     | "property:IntegerValue" 
     | "property:RealRangeValue" 
     | "property:RealValue" 
     | "property:BooleanValue"
     }}

 (* It is a property expression in AADL; why it is tagged propertyValue? *)
 and propertyExpression = 
    {{<propertyValue
	 xsi:type=propertyChoice
	 valueString=?String
	 value=?String
	 unitLiteral=?String 
	 referenceElement=?String 
	 enumLiteral=?String 
	 base=?String
	 delta=?String
     >
     [(minimum maximum)?]
     }}

 and minimum = {{<minimum xsi:type=?String 
				  valueString=String value=String 
				  unitLiteral=?String 
				  base=?String>[]}}
 and maximum = {{<maximum xsi:type=?String 
				  valueString=String value=String
				  unitLiteral=?String base=?String>[]}}

 and comment = {{<comment>[ ( Char )* ]}}


(* and property_set =   (** TODO *) *)
(* and component_type =  (** TODO *) *)
(* and component_type_extension =  (** TODO *) *)
(* and component_implementation  =  (** TODO *) *)
(* and component_implementation_extension =  (** TODO *) *)
(* and annex_library =  (** TODO *) *)

