(** Functions to get properties from components. 

    As one can see, very few properties are taken into account for the
    time being...

    Moreover, time units are ignored.

    Time-stamp: <modified the 03/09/2007 (at 14:22) by Erwan Jahier>  
     
    @author Louis Mandel 
    @author Erwan Jahier  
*)

(** [get_period c] returns period of the thread [c]. Raises
    [Not_found] if no period is associated to [c]. *)
val get_period:  Aadl_ast.component -> int


type dispatch_protocol =
  | Periodic
  | Aperiodic
  | Sporadic
  | Backgroud

(** [get_dispatch_protocol c] returns dispatch protocol of the comp [c]. 
    Raises [Not_found] if no period is associated to [c]. *)
val get_dispatch_protocol:  Aadl_ast.component -> dispatch_protocol

(** [get_compute_execution_time c] returns the compute execution time
    interval of component [c] . *)
val get_compute_execution_time:  
  Aadl_ast.component -> Ident.integer * Ident.integer


(** [get_processor_binding c] returns the period of the component
[c]. Raises [Not_found] if no processor binding is associated to
[c]. *)
val get_processor_binding:  
  Aadl_ast.component -> (Ident.t * (Ident.t * Ident.t)) list

type access_mode = Read | Write | ReadWrite | ByMethod

val get_provided_access_mode : Aadl_ast.property list -> access_mode
val get_required_access_mode : Aadl_ast.property list -> access_mode
